/*
 *****************************
 * 
 * Forma
 *
 *****************************
 * 
 * Objeto que almacena los puntos que conforman 
 * una forma que se encuentra una imagen
 *
 *
 * Jose Luis Ortigosa Flores
 * 25-sep-2015
 *
 */
#include <stdlib.h>
#include "../include/ArrayList.h"
#include "../include/Punto.h"

#ifndef FORMA_H
#define FORMA_H 1

typedef struct _Forma {
    ArrayList* vertices;
    Punto max;
    Punto min;
    int numPoints;
    Punto* var;
} Forma;

Forma* new_Forma();

// agrega un punto a la forma
void Forma_addPoint(Forma* f, Punto* p);

// agrega un punto a la forma
void Forma_add(Forma* f, int x, int y);

// regresa la cantidad de puntos que la conforman
int Forma_getNumPoints(Forma* f);

// obtiene el punto maximo dentro de la forma
Punto* Forma_getMaxPoint(Forma* f);

// obtiene el punto minimo dentro de la forma
Punto* Forma_getMinPoint(Forma* f);

//libera la memoria
void Forma_free(Forma* f);

// print forma
void Forma_print(void* o);

// checa y actualiza si el punto p es major
void actualizarPuntoMax(Forma* f, Punto* p);

// checa y actualiza si el punto p es menor
void actualizarPuntoMin(Forma* f, Punto* p);

// regresa la lista de vertices
ArrayList* Forma_getVertices(Forma* f);

// Agrega un vertice
void Forma_addVertice(Forma* f, Punto* p);

void Forma_setVerticeAnguloRecto(Forma* f, Punto* p);

Punto* Forma_getVerticeAnguloRecto(Forma* f);

ArrayList* Forma_escogerVertices(ArrayList* vertices);

#endif



