/*
 ******************
 *       Punto
 ******************
 * 
 * Objeto de tipo punto
 *
 * Jose Luis Ortigosa Flores
 * 25-sep-2015
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include "../include/Punto.h"
/*

typedef struct _Punto{
    int x;
    int y;
} Punto;

*/

// funcion para comparar puntos con respecto a x
int Punto_cmpX(void* a,void* b) {
    Punto* v = (Punto*)a;
    Punto* w = (Punto*)b;

    if(v->x > w->x) return 1;    
    if(v->x == w->x) return 0;
    return -1;
}

// funcion para comparar puntos con respecto a y
int Punto_cmpY(void* a,void* b) {
    Punto* v = (Punto*)a;
    Punto* w = (Punto*)b;

    if(v->y > w->y) return 1;
    if(v->y == w->y) return 0;
    return -1;
}

int Punto_equals(void* o1, void* o2) {
    Punto* a = (Punto*)o1;
    Punto* b = (Punto*)o2;
    return a->x == b->x && a->y == b->y;
}

//crea un punto nuevo
Punto* new_Punto(int y, int x) {
    Punto* p = (Punto*) malloc(sizeof(Punto));
    if(p == NULL) {
	exit(-1);
    }
    p->x = x;
    p->y = y;
    return p;
}

// libera la memoria
void Punto_free(Punto* p) {
    free(p);
}

// imprime un punto
void Punto_print(void* o) {
    Punto* p = (Punto*)o;
    printf("[%d,%d]", p->x, p->y);
}

Punto* Punto_restar(Punto* a, Punto* b) {
    return new_Punto(a->x-b->x, a->y-b->y);
}

Punto* Punto_restarAbs(Punto* a, Punto* b) {
    Punto* p = Punto_restar(a,b);
    if(p->x < 0) p->x *= -1;
    if(p->y < 0) p->y *= -1;
    return p;
}

int Punto_prodEscalar(Punto* a, Punto* b) {
    return a->x*b->x + a->y*b->y;
}

double Punto_area(Punto*a, Punto* b) {

    return (1/2.0)*(a->x*b->y-b->x*a->y);
}

